*******************************************************************
* Ownerdrawing, Beispiel 4:
* - Aktive Zellen in anderer Schriftart (fett)
* - Zweizeilige Anzeige der Adresse, zweite Zeile in kleinerer Schrift
*******************************************************************

#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#pragma Library( "XppUi2.lib" )

#define CRLF Chr(13)+Chr(10)

STATIC aData
STATIC nLastRec
STATIC nRecno
STATIC oFontNormal
STATIC oFontHilite
STATIC oFontSmall
STATIC oFontSmallHilite

PROCEDURE AppSys; RETURN

FUNCTION Main()
LOCAL oDlg, oBrowse, oColumn, oXbp, mp1, mp2, nEvent, aPres, aColPres

oFontNormal      := XbpFont():New():Create("9.Arial")
oFontSmall       := XbpFont():New():Create("8.Arial")
oFontHilite      := XbpFont():New():Create("9.Arial Fett")
oFontSmallHilite := XbpFont():New():Create("8.Arial Fett")

aPres := ;
  { { XBP_PP_COL_DA_ROWHEIGHT, 30 }, ; // hher, weil ggf. zweizeilig
    { XBP_PP_COL_DA_CELLHEIGHT, 30 }, ;
    { XBP_PP_COL_DA_ROWSEPARATOR, IF(IsThemeActive(),XBPCOL_SEP_LINE,XBPCOL_SEP_NONE) }, ;
    { XBP_PP_COL_DA_COLSEPARATOR, IF(IsThemeActive(),XBPCOL_SEP_LINE,XBPCOL_SEP_NONE) }, ;
    { XBP_PP_HILITE_BGCLR, GraMakeRGBColor({136,170,214}) }, ;
    { XBP_PP_HILITE_FGCLR, GraMakeRGBColor({255,102,51}) }, ;
    { XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_BOX+XBPFRAME_RECESSED }, ;
    { XBP_PP_COL_FA_FRAMELAYOUT, XBPFRAME_BOX+XBPFRAME_RECESSED }, ;
    { XBP_PP_COL_DA_FRAMELAYOUT, XBPFRAME_NONE }, ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK } , ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE } }

aColPres := aClone(aPres)
aAdd(aPres,   { XBP_PP_COL_DA_CELLALIGNMENT, XBPALIGN_LEFT+XBPALIGN_VCENTER })
aAdd(aColPres,{ XBP_PP_COL_DA_CELLALIGNMENT, XBPALIGN_RIGHT+XBPALIGN_VCENTER })

aData := {{1,'grn'   ,'Maier'  ,'Berlin'+CRLF+'Kurfrstendamm' },;
          {2,'gelb'   ,'Mller' ,'Berlin'+CRLF+'Adenauer Platz' },;
          {3,'blau'   ,'Schulze','Berlin'+CRLF+'Kottbusser Damm' },;
          {4,'grn'   ,'Albers' ,'Hamburg'+CRLF+'Mnkebergstrae'},;
          {5,'rot'    ,'Mayer'  ,'Mnchen'+CRLF+'Viktualienmarkt'},;
          {6,'schwarz','Kabel'  ,'Kln'+CRLF+'Am Dom'}}

nRecno := 1
nLastRec := Len(aData)

oDlg := XbpDialog():new(,,,,, .F. )
   oDlg:taskList                 := .T.
   oDlg:clientSize               := { 600, 500 }
   oDlg:drawingArea:clipChildren := .T.
   oDlg:title                    := 'Beispiel 4'
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( '9.Arial' )
   CenterControl( oDlg )
   SetAppWindow( oDlg )

oBrowse := XbpBrowse():new( oDlg:drawingArea,, { 0, 0 }, oDlg:drawingArea:currentSize(),, .F. )
  oBrowse:SkipBlock     := {|nSkip,oBrowse| DoSkip(nSkip,oBrowse) }
  oBrowse:GoBottomBlock := {|| nRecno := Len(aData) }
  oBrowse:GoTopBlock    := {|| nRecno := 1 }
  oBrowse:PosBlock      := {|| nRecno }
  oBrowse:PhyPosBlock   := {|| nRecno }
  oBrowse:LastPosBlock  := {|| Len(aData) }
  oBrowse:FirstPosBlock := {|| 1 }
  oBrowse:CursorMode    := XBPBRW_CURSOR_ROW
  oBrowse:SetPresParam(aPres)
  oBrowse:create()

   * 1. Spalte
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,1]}, 10, "Nummer" )
   * 2. Spalte, CustomDrawCell
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,2]}, 10, "Farbe" )
   oColumn:Configure(,,,,aColPres,.T.)
   oColumn:ColorBlock := {|x|{MyGetColor(x),GRA_CLR_WHITE}}
   oColumn:DataArea:DrawMode := XBP_DRAW_OWNER
   oColumn:DataArea:CustomDrawCell := {|oPs,aInfo,oArea|PaintCellWithForeGround(oPs,aInfo,oArea)}
   * 3. Spalte, CustomDrawCell
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,3]}, 20, "Name" )
   oColumn:ColorBlock := {||{GRA_CLR_BLUE,GRA_CLR_YELLOW}}
   oColumn:DrawMode := XBP_DRAW_OWNER
   oColumn:DataArea:CustomDrawCell := {|oPs,aInfo,oArea|PaintCellWithForeGround(oPs,aInfo,oArea)}
   * 4. Spalte, zweizeilig - CustomDrawCell
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,4]}, 20, "Ort" )
   oColumn:DrawMode := XBP_DRAW_OWNER
   oColumn:DataArea:CustomDrawCell := {|oPs,aInfo,oArea|PaintCellWithForeGround(oPs,aInfo,oArea)}

oBrowse:show()
oDlg:show()

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN NIL

******************************************************
* Hier werden die Zellen gezeichnet
******************************************************

FUNCTION PaintCellWithForeGround(oPs,aInfo,oArea)
* Erhebt das Alignment, die Vordergrundfarbe und zeichnet dann den Zellinhalt selbst
LOCAL xData, nFgCol, nAlign := XBPALIGN_VCENTER+XBPALIGN_HCENTER, aPP, nFound, xData1, xData2

* Zellinhalt erheben:
xData:= oArea:GetCell( aInfo[ XBP_DRAWINFO_ITEM ] )
IF xData = nil .or. !32 $ aInfo[ XBP_DRAWINFO_ACTION ] // nur selbst zeichnen, wenn Inhalt vorhanden und Vordergrund gezeichnet werden muss!
  RETURN .T.
ENDIF

* Vordergrundfarbe erheben:
oArea:GetCellColor( aInfo[ XBP_DRAWINFO_ITEM ],@nFgCol )
* und fr den Presentation Space setzen:
oPs:SetColor(nFgCol)

* Font setzen abhngig davon, ob selektiert oder nicht:
IF aInfo[XBP_DRAWINFO_STATE] = XBP_DRAWSTATE_SELECTED
  oPs:SetFont(oFontHilite)
  ELSE
  oPs:SetFont(oFontNormal)
ENDIF


* Alignment der Spalte erheben:
aPP := oArea:SetParent():SetPresParam()
nFound := AScan(aPP,{|a|Valtype(a[1])=='N' .AND. a[1]==XBP_PP_COL_DA_CELLALIGNMENT } )
IF nFound > 0 .and. aPP[nFound,2] <> nil
  nAlign := aPP[nFound,2]
ENDIF

* Text anzeigen (der eigentliche Kern der Angelegenheit):
IF CRLF $ xData // enthlt einen Zeilenumbruch
  xData1 := Trim(Left(xData,At(CRLF,xData)-1))
  xData2 := Trim(SubStr(xData,At(CRLF,xData)+2,Len(xData)-(At(CRLF,xData))))
  GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ]+15 }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData1, nAlign )
  IF aInfo[XBP_DRAWINFO_STATE] = XBP_DRAWSTATE_SELECTED
    oPs:SetFont(oFontSmallHilite)
    ELSE
    oPs:SetFont(oFontSmall)
  ENDIF
  GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 2 ]+15 }, xData2, nAlign )
  ELSE
  GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData, nAlign )
ENDIF

* Rckgabe .T. wrde bewirken, dass die Zelle berzeichnet wird! (Einfach mal ausprobieren!)
RETURN .F.

******************************************************


STATIC FUNCTION MyGetColor(x)
DO CASE
  CASE x = 'grn'
  RETURN GRA_CLR_GREEN
  CASE x = 'gelb'
  RETURN GRA_CLR_YELLOW
  CASE x = 'blau'
  RETURN GRA_CLR_BLUE
  CASE x = 'rot'
  RETURN GRA_CLR_RED
  CASE x = 'schwarz'
  RETURN GRA_CLR_BLACK
ENDCASE
RETURN GRA_CLR_BLACK

FUNCTION DoSkip( nSkip )
LOCAL nCanSkip
  IF nRecno + nSkip < 1             // "BoF"
     nCanSkip := 1 - nRecno
  ELSEIF nRecno + nSkip > nLastRec  // "EoF"
     nCanSkip := nLastRec - nRecno
  ELSE
     nCanSkip := nSkip
  ENDIF
  nRecno += nCanSkip
RETURN nCanSkip

